package clustering;

class CDR3 {
		//array list to hold the iHMMune-align result for each sequence from a specified file
		//ArrayList iHMMuneAlignResults = new ArrayList();
		
		//vars to hold the features of an iHMMune-align partitioning result
		private String seqID;
		private String IGHVName;
		private String IGHDName;
		private String IGHJName;
		private String CDR3;
		private int CDR3length;
		
		private String IGHVSeq;
		private String N1Seq;
		private String IGHDSeq;
		private String N2Seq;
		private String IGHJSeq;
		private String VMut;
		private String DMut;
		private String JMut;
		private String original;
		
		//brief iHMMune-align representation with V/D/J names, seqs and mutations only
		public CDR3 (String seqID, String IGHVName, String IGHDName, String IGHJName,String CDR3,int CDR3length, String IGHVSeq, String N1Seq, String IGHDSeq, String N2Seq, String IGHJSeq,
								   String VMut, String DMut, String JMut,String original) 
		{
			this.seqID = seqID;
			this.IGHVName = IGHVName;
			this.IGHDName = IGHDName;
			this.IGHJName = IGHJName;
			this.CDR3 = CDR3;
			this.CDR3length = CDR3length;
			this.IGHVSeq = IGHVSeq;
			this.N1Seq = N1Seq;
			this.IGHDSeq = IGHDSeq;
			this.N2Seq = N2Seq;
			this.IGHJSeq = IGHJSeq;
			this.VMut = VMut;
			this.DMut = DMut;
			this.JMut = JMut;
			this.original = original;
		}
		
		//add a function to get the seqID
		public String getSeqID()
		{
			return seqID;
		}
		
		//add a function to get the IGHVName
		public String getIGHVName()
		{
			return IGHVName;
		}
		
		//get the IGHD gene name
		public String getIGHDName()
		{
			return IGHDName;
		}
		
		//get the IGHJ gene name
		public String getIGHJName()
		{
			return IGHJName;
		}
		
		//get the CDR3 sequence
		public String getCDR3() {
			return CDR3;
		}

		//get the CDR3 length
		public int getCDR3length() {
			return CDR3length;
		}

		//get the V region sequence
		public String getVSeq()
		{
			//char[] IGHVSeqArr = IGHVSeq.toCharArray();
			return IGHVSeq;
		}
		
		//get the N1 sequence
		public char[] getN1Seq() 
		{
			char[] N1SeqArr = N1Seq.toCharArray();
			return N1SeqArr;
		}
		
		//get the D region seq
		public char[] getDSeq()
		{
			char[] DSeqArr = IGHDSeq.toCharArray();
			return DSeqArr;
		}
		
		//get the N2 region seq
		public char[] getN2Seq()
		{
			char[] N2SeqArr = N2Seq.toCharArray();
			return N2SeqArr;
		}
		
		//J region sequence
		public char[] getJSeq() 
		{
			char[] JSeqArr = IGHJSeq.toCharArray();
			return JSeqArr;
		}
		
		//V mutation number
		public String getVMut()
		{
			//int VMutInt = Integer.parseInt(VMut);
			//return VMutInt;
			return VMut;
		}
		
		//D mutation number
		public int getDMut()
		{
			int DMutInt = Integer.parseInt(DMut);
			return DMutInt;
		}
		
		//J mut no
		public int getJMut()
		{
			int JMutInt = Integer.parseInt(JMut);
			return JMutInt;
		}
		
		public String getOriginal() {
			return original;
		}
}
