package clustering;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;

public class NewFindCDR {

	/**
	 * @param args
	 */

	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		String inputFilename = InOutFileName.getInputFilename();
		NewFindCDR findcdr = new NewFindCDR();
		findcdr.getCDR3s(inputFilename);

	}

	public ArrayList<CDR3> getCDR3s(String inputFilename) throws Exception {
		// String inputFilename = InOutFileName.getInputFilename();
		HashMap<String, Integer> Vdict = getV();
		HashMap<String, Integer> Jdict = getJ();
		ArrayList<CDR3> cdr3s = generateCDR3s(inputFilename, Vdict, Jdict);
		// String outputFilename = inputFilename+".outputCDR3.txt";
		// outputCDR3(outputFilename, cdr3s);
		return cdr3s;
	}

	public ArrayList<CDR3> generateCDR3s(String inputFilename,
			HashMap<String, Integer> Vdict, HashMap<String, Integer> Jdict)
			throws Exception {
		ArrayList<CDR3> cdr3s = new ArrayList<CDR3>();

		String delimiter = ";";

		// open up the iHMMune-align results file for reading
		File iHMMuneAlignFile = new File(inputFilename);

		// try reading the iHMMune-align results from the file
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					iHMMuneAlignFile));

			// work through each line in the input file
			for (String line = br.readLine(); line != null; line = br
					.readLine()) {
				// extract the data for the sequence from the line read from the
				// file
				line = line.replace("\"", "");
				String[] lineData = line.split(delimiter);

				if (lineData.length > 1) { // skip blank lines
					String seqID = lineData[0];
					//System.out.println(seqID);
					String IGHVName = lineData[1];
					String IGHDName = lineData[2];
					String IGHJName = lineData[3];
					String IGHVSeq = lineData[4];
					String N1Seq = lineData[5];
					String IGHDSeq = lineData[6];
					String N2Seq = lineData[7];
					String IGHJSeq = lineData[8];
					String VMut = lineData[9];
					String DMut = lineData[10];
					String JMut = lineData[11];
					// System.out.println(rest);
					if (!IGHDName.equals("NA")) {
						String CDR3 = getCDR3seq(IGHVName, IGHJName, IGHVSeq,
								N1Seq, IGHDSeq, N2Seq, IGHJSeq, Vdict, Jdict);
						int CDR3length = CDR3.length();
						// add the result to the arraylist
						cdr3s.add(new CDR3(seqID, IGHVName, IGHDName, IGHJName,
								CDR3, CDR3length, IGHVSeq, N1Seq, IGHDSeq,
								N2Seq, IGHJSeq, VMut, DMut, JMut, line));
					}
				}
			}
			// System.out.println(cdr3s.size());
			return cdr3s;

		} catch (IOException IOE) {
			throw new Error(
					"(ClonalRelate:loadiHMMuneAlignResults) Could not read the specified iHMMune-align results file: "
							+ inputFilename + "\n" + IOE.getMessage());
		}
	}

	public String getCDR3seq(String IGHVName, String IGHJName, String IGHVSeq,
			String N1Seq, String IGHDSeq, String N2Seq, String IGHJSeq,
			HashMap<String, Integer> Vdict, HashMap<String, Integer> Jdict) {
		try {
			// String cdr3seq = "";
			String vname = IGHVName.split("[ _/(]")[0].replace("\"", "");
			//System.out.println(vname);
			//System.out.println(Vdict.get(vname));
			if (IGHVName.contains("_")) {
				if (IGHVName.indexOf("_") < IGHVName.indexOf("IGHV")) {
					vname = IGHVName.split("[_/(]")[1].replace("\"", "");
				}
			}
			String jname = "";
			if(IGHJName.contains("[")){
			jname = IGHJName.split("[ /(]")[0].replace("\"", "");
			}
			else{
				jname = IGHJName;
			}
			//System.out.println(jname);
			String start = IGHVSeq.replace("\"", "").substring(
					(IGHVSeq.length() - Vdict.get(vname))).replace(".", "");
			//System.out.println(start);
			String end = IGHJSeq.replace("\"", "").substring(0,
					Jdict.get(jname) + 1).replace(".", "");
			String cdr3seq = start + N1Seq + IGHDSeq.replace(".", "") + N2Seq
					+ end;
			//System.out.println(end);
			return cdr3seq;
		} catch (Exception exception) {
			throw new Error("IGHV not in repertoire:" + IGHVName);
		}
	}

	public HashMap<String, Integer> getV() throws Exception {
		// BufferedReader reader = new BufferedReader(new
		// InputStreamReader(System.in));
		// System.
		BufferedReader vreader = new BufferedReader(new InputStreamReader(
				new FileInputStream(new File(InOutFileName.getRootPath()
						+ "/repertoire/IGHV_Repertoire_CDR3_old.csv"))));
		String vdictinput = null;
		HashMap<String, Integer> Vdict = new HashMap<String, Integer>();

		while ((vdictinput = vreader.readLine()) != null) {
			// Get repertoire input
			String[] VdictList = vdictinput.split(",");
			// V gene name and confidence level is seperated by "_"
			String[] VGeneName = VdictList[0].split("[_(]");
			// Get V gene name and allele, but not confidence level
			String VGene = VGeneName[0];
			// System.out.println(VGene);
			// Get CDR3 starting sequence length in V
			Integer VSeqLen = Integer.parseInt(VdictList[2]);
			Vdict.put(VGene, VSeqLen);
		}
		//System.out.println(Vdict);
		return Vdict;
	}

	public HashMap<String, Integer> getJ() throws Exception {
		// BufferedReader reader = new BufferedReader(new
		// InputStreamReader(System.in));
		BufferedReader jreader = new BufferedReader(new InputStreamReader(
				new FileInputStream(new File(InOutFileName.getRootPath()
						+ "/repertoire/IGHJ_Repertoire_CDR3.csv"))));
		String jdictinput = null;
		HashMap<String, Integer> Jdict = new HashMap<String, Integer>();
		while ((jdictinput = jreader.readLine()) != null) {
			// Get J repertoire input
			String[] JdictList = jdictinput.split(",");
			// Get J gene name and allele
			String JGene = JdictList[0];
			// Get CDR3 ending sequence length in J
			// System.out.println(JGene);
			Integer JSeqLen = Integer.parseInt(JdictList[2]);
			Jdict.put(JGene, JSeqLen);
		}

		return Jdict;
	}

	public void outputCDR3(String outputFilename, ArrayList<CDR3> cdr3s) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < cdr3s.size(); i++) {
			CDR3 cdr3 = cdr3s.get(i);
			sb.append(cdr3.getOriginal().replace("\n", ""));
			sb.append(";");
			sb.append(cdr3.getCDR3());
			sb.append(";");
			sb.append(Integer.toString(cdr3.getCDR3length()));
			sb.append("\n");
		}
		try {
			// PrintWriter writer = new PrintWriter(new FileOutputStream(new
			// File("CDR3.txt")));
			PrintWriter writer = new PrintWriter(outputFilename);
			writer.print(sb.toString());
			writer.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}
