package clustering;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Collection;

import com.giantleap.common.nodebean.node.base.storage.node.Node;

import clustering.node.Folder;
import clustering.node.Leaf;

public class NewickConverter {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		System.out.println("Input an XML tree");
		String inputFilename = InOutFileName.getInputFilename();
		NewickConverter conv = new NewickConverter();
		conv.converter(inputFilename);

		// System.out.println(newick_string);
	}

	public void converter(String xmlfilename) {
		try {
			NewClonalRelate clustering = new NewClonalRelate();

			Folder folder = clustering.loadTree(xmlfilename);

			String parent_id = "first";
			String first_newick_string = "(first)";
			String newick_string = update_newick(folder, parent_id,
					first_newick_string);
			// return newick_string;
			newick_string+=";";
			PrintWriter writer = new PrintWriter(xmlfilename+".newick");
			writer.print(newick_string);
			writer.flush();
			writer.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void readFile() {
		try {
			System.out.println("Input an XML tree");
			String inputFilename = InOutFileName.getInputFilename();
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(new File(inputFilename))));
			String input = null;

			while ((input = reader.readLine()) != null) {

				System.out.println(input);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public String update_newick(Folder folder, String parent_id,
			String newick_string) {
		if (folder.isNode()) {
			float half_dist = half_dist(folder);
			Collection<Node> nodes = folder.getAllChildNode();
			String updating_newick = "(";
			for (Node node : nodes) {
				if (node instanceof Leaf) {
					Leaf l = (Leaf) node;
					// NodeId nodeid = l.getId();
					Leaf leaf_child = (Leaf) folder.getChildNode(l
							.getIdString());
					String leaf_id = leaf_child.get_id();
					updating_newick += leaf_id + ":"
							+ Float.toString(half_dist) + ",";
				} else if (node instanceof Node) {
					Folder f = (Folder) node;
					String folder_id = f.getId().toString();
					updating_newick += folder_id + ":"
							+ Float.toString(half_dist) + ",";
				}
			}
			updating_newick = updating_newick.substring(0, updating_newick
					.lastIndexOf(","))
					+ ")";
			// System.out.println(updating_newick);
			newick_string = newick_string.replace(parent_id, updating_newick);
			// System.out.println(newick_string);
		}
		Collection<Node> nodes = folder.getAllChildNode();
		// System.out.println(nodes.size());
		for (Node node : nodes) {
			if (node instanceof Folder) {
				Folder f = (Folder) node;
				parent_id = f.getIdString();
				//updating newick_string recursively
				newick_string = update_newick(f, parent_id, newick_string);
			}
		}
		// System.out.println(newick_string);
		
		return newick_string;

	}

	private Float half_dist(Folder folder) {
		float dist = folder.get_dist();
		float half_dist = (float) (dist * 0.5);
		Collection<Node> nodes = folder.getAllChildNode();
		for (Node node : nodes) {
			if (node instanceof Folder) {
				Folder f = (Folder) node;
				float child_dist = f.get_dist();
				half_dist = (float) ((dist - child_dist) * 0.5);
			}
		}

		return half_dist;
	}
}
