package clustering;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class ReadiHMMResults {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		String inputFilename = null;
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		inputFilename = reader.readLine();
		ReadiHMMResults readfile = new ReadiHMMResults();
		ArrayList<IHMMuneResult> iHMMuneAlignResults = readfile.loadiHMMuneAlignResults(inputFilename);
		System.out.println(iHMMuneAlignResults.size());
	}
	
	
	public ArrayList<IHMMuneResult> loadiHMMuneAlignResults(String inputFilename) {
		// load the iHMMune-align input file
		
		ArrayList<IHMMuneResult> iHMMuneAlignResults = new ArrayList<IHMMuneResult>();
		// delimiter used in the iHMMuneAlign file
		String delimiter = ";";

		// open up the iHMMune-align results file for reading
		File iHMMuneAlignFile = new File(inputFilename);

		// try reading the iHMMune-align results from the file
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					iHMMuneAlignFile));

			// work through each line in the input file
			for (String line = br.readLine(); line != null; line = br
					.readLine()) {
				// extract the data for the sequence from the line read from the
				// file
				line = line.replace("\"", "");
				String[] lineData = line.split(delimiter);

				if (lineData.length > 1) { // skip blank lines
					String seqID = lineData[0];
					String IGHVName = lineData[1];
					String IGHDName = lineData[2];
					String IGHJName = lineData[3];
					String IGHVSeq = lineData[4];
					String N1Seq = lineData[5];
					String IGHDSeq = lineData[6];
					String N2Seq = lineData[7];
					String IGHJSeq = lineData[8];
					String VMut = lineData[9];
					String DMut = lineData[10];
					String JMut = lineData[11];

					// add the result to the arraylist
					iHMMuneAlignResults.add(new IHMMuneResult(seqID,
							IGHVName, IGHDName, IGHJName, IGHVSeq, N1Seq,
							IGHDSeq, N2Seq, IGHJSeq, VMut, DMut, JMut));
				}
			}

			return iHMMuneAlignResults;

		} catch (IOException IOE) {
			throw new Error(
					"(ClonalRelate:loadiHMMuneAlignResults) Could not read the specified iHMMune-align results file: "
							+ inputFilename + "\n" + IOE.getMessage());
		}

	}
}
